{string constants for drives.pas}

{The error class may be one of the following}
 	eClassStr: array[0..$0D] of string = (
{OK											}'OK',
{ERRCLASS_OUTRES (01h)	}'Out of resource, such as storage.',
{ERRCLASS_TEMPSIT (02h)	}'Not an error, temporary situation (file or record lock)',
{ERRCLASS_AUTH (03h)		}'Authorization problem.',
{ERRCLASS_INTRN (04h)		}'Internal error in system.',
{ERRCLASS_HRDFAIL (05h)	}'Hardware failure.',
{ERRCLASS_SYSFAIL (06h)	}'System software failure (missing or incorrect configuration files).',
{ERRCLASS_APPERR (07h)	}'Application error.',
{ERRCLASS_NOTFND (08h)  }'File or item not found.',
{ERRCLASS_BADFMT (09h)  }'File or item with an invalid format or type.',
{ERRCLASS_LOCKED (0Ah)  }'Interlocked file or item.',
{ERRCLASS_MEDIA (0Bh)   }'Wrong disk in drive, bad spot on disk, or other storage-medium problem.',
{ERRCLASS_ALREADY (0Ch) }'Existing file or item.',
{ERRCLASS_UNK (0Dh)	 	  }'Unknown.');

{*The suggested action may be one of the following:}
 	eActionStr: array[0..$07] of string = (
{OK											}'OK',
{ERRACT_RETRY (01h)			}'Retry immediately.',
{ERRACT_DLYRET (02h)		}'Delay and retry.',
{ERRACT_USER (03h)			}'Bad user input, get new values.',
{ERRACT_ABORT (04h)			}'Terminate in an orderly manner.',
{ERRACT_PANIC (05h)			}'Terminate immediately.',
{ERRACT_IGNORE (06h)		}'Ignore the error.',
{ERRACT_INTRET (07h)		}'Remove the cause of the error (to change disks, for example) and then retry.');

{The error location may be one of the following:}
eLocusStr: array[0..$05] of string = (
{OK											}'OK',
{ERRLOC_UNK (01h)				}'Unknown',
{ERRLOC_DISK (02h)			}'Random-access device, such as a disk drive',
{ERRLOC_NET (03h)				}'Network',
{ERRLOC_SERDEV (04h)		}'Serial device',
{ERRLOC_MEM (05h)				}'Memory');

{MS DOS error codes}
eDosErrorStr: array[0..$5A] of string = (
{0000h  non error} 'OK',
{0001h}	'ERROR_INVALID_FUNCTION',
{0002h}	'ERROR_FILE_NOT_FOUND',
{0003h}	'ERROR_PATH_NOT_FOUND',
{0004h}	'ERROR_TOO_MANY_OPEN_FILES',
{0005h}	'ERROR_ACCESS_DENIED',
{0006h}	'ERROR_INVALID_HANDLE',
{0007h}	'ERROR_ARENA_TRASHED',
{0008h}	'ERROR_NOT_ENOUGH_MEMORY',
{0009h}	'ERROR_INVALID_BLOCK',
{000Ah}	'ERROR_BAD_ENVIRONMENT',
{000Bh}	'ERROR_BAD_FORMAT',
{000Ch}	'ERROR_INVALID_ACCESS',
{000Dh}	'ERROR_INVALID_DATA',
{000Eh} 'Reserved',
{000Fh}	'ERROR_INVALID_DRIVE',
{0010h}	'ERROR_CURRENT_DIRECTORY',
{0011h}	'ERROR_NOT_SAME_DEVICE',
{0012h}	'ERROR_NO_MORE_FILES',
{0013h}	'ERROR_WRITE_PROTECT',
{0014h}	'ERROR_BAD_UNIT',
{0015h}	'ERROR_NOT_READY',
{0016h}	'ERROR_BAD_COMMAND',
{0017h}	'ERROR_CRC',
{0018h}	'ERROR_BAD_LENGTH',
{0019h}	'ERROR_SEEK',
{001Ah}	'ERROR_NOT_DOS_DISK',
{001Bh}	'ERROR_SECTOR_NOT_FOUND',
{001Ch}	'ERROR_OUT_OF_PAPER',
{001Dh}	'ERROR_WRITE_FAULT',
{001Eh}	'ERROR_READ_FAULT',
{001Fh}	'ERROR_GEN_FAILURE',
{0020h}	'ERROR_SHARING_VIOLATION',
{0021h}	'ERROR_LOCK_VIOLATION',
{0022h}	'ERROR_WRONG_DISK',
{0023h}	'ERROR_FCB_UNAVAILABLE',
{0024h}	'ERROR_SHARING_BUFFER_EXCEEDED',
{0025h}	'ERROR_CODE_PAGE_MISMATCHED',
{0026h}	'ERROR_HANDLE_EOF',
{0027h}	'ERROR_HANDLE_DISK_FULL',
{0028h} 'Reserved',
{0029h} 'Reserved',
{002Ah} 'Reserved',
{002Bh} 'Reserved',
{002Ch} 'Reserved',
{002Dh} 'Reserved',
{002Eh} 'Reserved',
{002Fh} 'Reserved',
{0030h} 'Reserved',
{0031h} 'Reserved',
{0032h}	'ERROR_NOT_SUPPORTED',
{0033h}	'ERROR_REM_NOT_LIST',
{0034h}	'ERROR_DUP_NAME',
{0035h}	'ERROR_BAD_NETPATH',
{0036h}	'ERROR_NETWORK_BUSY',
{0037h}	'ERROR_DEV_NOT_EXIST',
{0038h}	'ERROR_TOO_MANY_CMDS',
{0039h}	'ERROR_ADAP_HDW_ERR',
{003Ah}	'ERROR_BAD_NET_RESP',
{003Bh}	'ERROR_UNEXP_NET_ERR',
{003Ch}	'ERROR_BAD_REM_ADAP',
{003Dh}	'ERROR_PRINTQ _FULL',
{003Eh}	'ERROR_NO_SPOOL_SPACE',
{003Fh}	'ERROR_PRINT_CANCELLED',
{0040h}	'ERROR_NETNAME_DELETED',
{0041h}	'ERROR_NETWORK_ACCESS_DENIED',
{0042h}	'ERROR_BAD_DEV_TYPE',
{0043h}	'ERROR_BAD_NET_NAME',
{0044h}	'ERROR_TOO_MANY_NAMES',
{0045h}	'ERROR_TOO_MANY_SESS',
{0046h}	'ERROR_SHARING_PAUSED',
{0047h}	'ERROR_ERROR_REQ _NOT_ACCEP',
{0048h}	'ERROR_REDIR_PAUSED',
{0049h} 'Reserved',
{004Ah} 'Reserved',
{004Bh} 'Reserved',
{004Ch} 'Reserved',
{004Dh} 'Reserved',
{004Eh} 'Reserved',
{004Fh} 'Reserved',
{0050h}	'ERROR_FILE_EXISTS',
{0051h}	'ERROR_DUP_FCB',
{0052h}	'ERROR_CANNOT_MAKE',
{0053h}	'ERROR_FAIL_I24',
{0054h}	'ERROR_OUT_OF_STRUCTURES',
{0055h}	'ERROR_ALREADY_ASSIGNED',
{0056h}	'ERROR_INVALID_PASSWORD',
{0057h}	'ERROR_INVALID_PARAMETER',
{0058h}	'ERROR_NET_WRITE_FAULT',
{0059h}	'Function not supported on Network',
{005Ah}	'ERROR_SYS_COMP_NOT_LOADED');

cDriveStr: array[0..8] of string = (
			'Unknown',
			'NoDrive',
			'3-1/2" floppy',
			'5-1/4" floppy',
		 	'hard',
			'removable hard',
			'network',
			'CD ROM',
      'tape');
