unit Testform;
{ for to test the drives.pas Unit

	Author: William R. Florac
  Company: FITCO, Verona, WI (wee little company from my house)
	Copyright 1996, FITCO.  All rights reserved.

	Revision History
		2/28/96
    	1.0 released
 }
interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Grids, FileCtrl, Drives;

type
  TForm1 = class(TForm)
    TestInt1: TButton;
    StringGrid1: TStringGrid;
    DriveToTest: TComboBox;
    Button2: TButton;
    DriveComboBox1: TDriveComboBox;
    DirectoryListBox1: TDirectoryListBox;
    TestInt2: TButton;
    Button4: TButton;
    Label1: TLabel;
    Button5: TButton;
    Label2: TLabel;
    CloseBtn: TButton;
    Button6: TButton;
    Button7: TButton;
    VolLabel: TEdit;
    Label13: TLabel;
    Button8: TButton;
    Button9: TButton;
    Label14: TLabel;
    Label15: TLabel;
    Label16: TLabel;
    Label17: TLabel;
    Button10: TButton;
    Label18: TLabel;
    Label19: TLabel;
    Label20: TLabel;
    Label21: TLabel;
    Label22: TLabel;
    VolSN: TEdit;
    GroupBox1: TGroupBox;
    Label7: TLabel;
    Label6: TLabel;
    Label5: TLabel;
    Label4: TLabel;
    Label3: TLabel;
    errCode: TLabel;
    errClass: TLabel;
    errAction: TLabel;
    errLocus: TLabel;
    errVolume: TLabel;
    procedure TestInt1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure DriveComboBox1Enter(Sender: TObject);
    procedure DriveComboBox1Exit(Sender: TObject);
    procedure TestInt2Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure CloseBtnClick(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure Button8Click(Sender: TObject);
    procedure Button9Click(Sender: TObject);
    procedure Button10Click(Sender: TObject);
  private
		{ Private declarations }
    procedure ShowExtErrors;
		procedure ClearExtErrors;
  public
    { Public declarations }
  end;



var
  Form1: TForm1;

implementation
{$R *.DFM}



{test interupt 21/440d/60}
procedure TForm1.TestInt1Click(Sender: TObject);
var
	nDrive: integer;
	dp: TDeviceParams;
	x: integer;
begin
	if DriveToTest.ItemIndex < 0 then exit;
	for x:= 0 to StringGrid1.RowCount - 1 do StringGrid1.rows[x].clear;
	dp.bSpecFunc := 0;
	nDrive := DriveToTest.ItemIndex;
{	nDrive := 0;}
	if GetDeviceParameters(nDrive, dp) then begin
		with StringGrid1 do begin
			Cells[1,0] := 'Value';
			Cells[0,0] := 'Description';
			Cells[0,1] := 'SpecFunc';				{Special functions}
			Cells[0,2] := 'DevType';				{Device type}
			Cells[0,3] := 'DevAttr';				{Device attributes}
			Cells[0,4] := 'Cylinders';			{Number of cylinders}
			Cells[0,5] := 'MediaType';			{Media type}
			Cells[0,6] := 'BytesPerSec';		{Bytes per sector}
			Cells[0,7]:= 'SecPerClust';		{Sectors per cluster}
			Cells[0,8] := 'ResSectors';			{Number of reserved sectors}
			Cells[0,9] := 'FATs';						{Number of FATs}
			Cells[0,10] := 'RootDirEnts';		{Number of root-directory entries}
			Cells[0,11] := 'Sectors';				{Total number of sectors}
			Cells[0,12] := 'Media';					{Media descriptor}
			Cells[0,13] := 'FATsecs';			{Number of sectors per FAT}
			Cells[0,14] := 'SecPerTrack';		{Number of sectors per track}
			Cells[0,15] := 'Heads';					{Number of heads}
			Cells[0,16] := 'HiddenSecs';		{Number of hidden sectors}
			Cells[0,17] := 'HugeSectors';	{Number of sectors if wSectors == 0}

			cells[1,1] := IntToHex(dp.bSpecFunc,2);
			cells[1,2] := IntToHex(dp.bDevType,2);
			cells[1,3] := IntToHex(dp.wDevAttr,4);
			cells[1,4] := IntToHex(dp.wCylinders,4);
			cells[1,5] := IntToHex(dp.bMediaType,2);
			cells[1,6] := IntToHex(dp.wBytesPerSec,4);
			cells[1,7] := IntToHex(dp.bSecPerClust,2);
			cells[1,8] := IntToHex(dp.wResSectors,4);
			cells[1,9] := IntToHex(dp.bFATs,2);
			cells[1,10] := IntToHex(dp.wRootDirEnts,2);
			cells[1,11] := IntToHex(dp.wSectors,2);
			cells[1,12] := IntToHex(dp.bMedia,2);
			cells[1,13] := IntToHex(dp.wFATsecs,4);
			cells[1,14] := IntToHex(dp.wSecPerTrack,4);
			cells[1,15] := IntToHex(dp.wHeads,4);
			cells[1,16] := IntToHex(dp.dwHiddenSecs,8);
			cells[1,17] := IntToHex(dp.dwHugeSectors,8);
		end;
		ClearExtErrors;
	end
	else ShowExtErrors;
end;

{some defaults}
procedure TForm1.FormCreate(Sender: TObject);
begin
	ClearExtErrors;
	DriveToTest.ItemIndex := 0;
end;


{stop dos critical error}
procedure TForm1.DriveComboBox1Enter(Sender: TObject);
begin
	SetErrorMode(SEM_FAILCRITICALERRORS);
end;

{a good programmer would retore the original!}
procedure TForm1.DriveComboBox1Exit(Sender: TObject);
begin
	SetErrorMode(0);
end;

{test interupt 21/69/0}
procedure TForm1.TestInt2Click(Sender: TObject);
var
	nDrive: integer;
	sn: TSerialNumberParams;
	x: integer;
	s: array[0..24] of char;
	e: word;
begin
	{note that the label returned here may not be the same as the one
   returned by DIR!}
	if DriveToTest.ItemIndex < 0 then exit;
	for x:= 0 to StringGrid1.RowCount - 1 do StringGrid1.rows[x].clear;
	nDrive := DriveToTest.ItemIndex;
	if ReadDriveSNParam(nDrive, @sn) then begin
		with StringGrid1 do begin
			Cells[0,0] := 'Description';
			Cells[1,0] := 'Value';

			Cells[0,1] := 'InfoLevel';				{Special functions}
			Cells[0,2] := 'SerialNumber';				{Device type}
			Cells[0,3] := 'Label';				{Device attributes}
			Cells[0,4] := 'FileSystem';			{Number of cylinders}

			cells[1,1] := IntToHex(sn.wInfoLevel,4);
			cells[1,2] := IntToHex(sn.dwDiskSerialNumber,8);
			StrMove(s,sn.caLabel,11);
			s[11] := #0;
			cells[1,3] := StrPas(s);
			StrMove(s,sn.baFileSystem,8);
			s[8] := #0;
			cells[1,4] := StrPas(s);
		end;
		ClearExtErrors;
	end
	else ShowExtErrors;
end;

{show last DOS error}
procedure TForm1.ShowExtErrors;
var
	Ep: TExtErrorParams;
begin
	GetExtendedErrorInfo(@ep);
	errCode.Caption := eDosErrorStr[ep.eCode];
	errClass.Caption := eClassStr[ep.eClass];
	errAction.Caption := eActionStr[ep.eAction];
	errLocus.Caption := eLocusStr[ep.eLocus];
	errVolume.Caption := ep.eVolume;
end;

{clear error list}
procedure TForm1.ClearExtErrors;
begin
	errCode.Caption := 'none';
	errClass.Caption := 'none';
	errAction.Caption := 'none';
	errLocus.Caption := 'none';
	errVolume.Caption := 'none';
end;

{get drive label}
procedure TForm1.Button4Click(Sender: TObject);
var
	wDrive: word;
	s: string;
begin
	if DriveToTest.ItemIndex < 0 then exit;
	wDrive := DriveToTest.ItemIndex;
	s := GetDriveLabel(wDrive);
	Label1.caption := s;
	ClearExtErrors;
	if s = 'NO NAME' then ShowExtErrors;
end;

{set drive label}
procedure TForm1.Button5Click(Sender: TObject);
var
	nDrive: integer;
begin
	if DriveToTest.ItemIndex < 0 then exit;
	nDrive := DriveToTest.ItemIndex;
	if SetDriveLabel(nDrive,VolLabel.Text) then begin
		label17.caption := 'pass';
		ClearExtErrors;
  end
  else begin
		label17.caption := 'fail';
		ShowExtErrors;
	end;
end;

{is drive ready}
procedure TForm1.Button2Click(Sender: TObject);
var
	wDrive: word;
begin
	if DriveToTest.ItemIndex < 0 then exit;
	wDrive := DriveToTest.ItemIndex;
	if DriveReady(wDrive) then begin
		Label2.Caption := 'true';
		ClearExtErrors;
	end
	else begin
		Label2.Caption := 'false';
		ShowExtErrors;
	end;
end;

{bye bye}
procedure TForm1.CloseBtnClick(Sender: TObject);
begin
	close;
end;

{is it a CDROM?}
procedure TForm1.Button6Click(Sender: TObject);
var
	nDrive: integer;
begin
	if DriveToTest.ItemIndex < 0 then exit;
	nDrive := DriveToTest.ItemIndex;
	if isCDROMDrive(nDrive)
  then Label13.Caption := 'true'
	else Label13.Caption := 'false';

end;

{get default drive number}
procedure TForm1.Button7Click(Sender: TObject);
var
	x: word;
begin
	x := GetDefaultDrive;
	Label14.Caption := inttostr(x);
end;

{get drive serial number}
procedure TForm1.Button8Click(Sender: TObject);
var
	wDrive: word;
	x: longint;
begin
	if DriveToTest.ItemIndex < 0 then exit;
	wDrive := DriveToTest.ItemIndex;
	x := GetDriveSerialNumber(wDrive);
	if x <> -1
	then begin
		ClearExtErrors;
		label15.Caption := inttohex(x,16)
  end
	else begin
		ShowExtErrors;
		label15.Caption := 'error';
	end;
end;

{set drive serial number}
procedure TForm1.Button9Click(Sender: TObject);
var
	wDrive: word;
	sn: integer;
begin
	if DriveToTest.ItemIndex < 0 then exit;
	wDrive := DriveToTest.ItemIndex;
	try
		sn := StrToInt(VolSN.Text);
	except
		begin
			messagebeep(0);
			exit;
		end
  end;

	if SetDriveSerialNumber(wDrive, sn)
	then begin
		label16.Caption := 'pass';
		ClearExtErrors;
  end
	else begin
		label16.Caption := 'fail';
		ShowExtErrors;
	end;
end;

{get drive type}
procedure TForm1.Button10Click(Sender: TObject);
var
	wDrive: word;
begin
	if DriveToTest.ItemIndex < 0 then exit;
	wDrive := DriveToTest.ItemIndex;
	Label18.caption := cDriveStr[word(GetDriveStyle(wDrive))] + ' drive';
end;

end.
